<a id="mypy-boto3-kendra"></a>

# mypy-boto3-kendra

[![PyPI - types-aiobotocore-kendra](https://img.shields.io/pypi/v/types-aiobotocore-kendra.svg?color=blue)](https://pypi.org/project/types-aiobotocore-kendra)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-kendra.svg?color=blue)](https://pypi.org/project/types-aiobotocore-kendra)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/types-aiobotocore-kendra?color=blue)](https://pypistats.org/packages/types-aiobotocore-kendra)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[boto3.kendra 1.20.47](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/kendra.html#kendra)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 6.4.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[types-aiobotocore-kendra docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_kendra/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/main/demo.gif)

- [mypy-boto3-kendra](#mypy-boto3-kendra)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [Versioning](#versioning)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `kendra`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `kendra` service.

```bash
# install with aiobotocore type annotations
python -m pip install 'types-aiobotocore[kendra]'

# Lite version does not provide session.create_client overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'types-aiobotocore-lite[kendra]'

# standalone installation
python -m pip install types-aiobotocore-kendra
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[kendra]` in your environment:
  `python -m pip install 'types-aiobotocore[kendra]'`

Both type checking and auto-complete should work for `kendra` service. No
explicit type annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

- Install `types-aiobotocore[kendra]` in your environment:
  `python -m pip install 'types-aiobotocore[kendra]'`

Both type checking and auto-complete should work for `kendra` service. No
explicit type annotations required, write your `aiobotocore` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed
`types-aiobotocore` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[kendra]` in your environment:
  `python -m pip install 'types-aiobotocore[kendra]'`
- Run `mypy` as usual

Type checking should work for `kendra` service. No explicit type annotations
required, write your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `types-aiobotocore[kendra]` in your environment:
  `python -m pip install 'types-aiobotocore[kendra]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `kendra` service. No explicit type annotations
required, write your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`kendraClient` provides annotations for `session.create_client("kendra")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_kendra import kendraClient

session = get_session()
async with session.create_client("kendra") as client:
    client: kendraClient
    # now client usage is checked by mypy and IDE should provide code auto-complete
```

<a id="literals"></a>

### Literals

`types_aiobotocore_kendra.literals` module contains literals extracted from
shapes that can be used in user code for type checking.

```python
from types_aiobotocore_kendra.literals import (
    AdditionalResultAttributeValueTypeType,
    ConditionOperatorType,
    ConfluenceAttachmentFieldNameType,
    ConfluenceBlogFieldNameType,
    ConfluencePageFieldNameType,
    ConfluenceSpaceFieldNameType,
    ConfluenceVersionType,
    ContentTypeType,
    DataSourceStatusType,
    DataSourceSyncJobStatusType,
    DataSourceTypeType,
    DatabaseEngineTypeType,
    DocumentAttributeValueTypeType,
    DocumentStatusType,
    EndpointTypeType,
    EntityTypeType,
    ErrorCodeType,
    ExperienceStatusType,
    FaqFileFormatType,
    FaqStatusType,
    HighlightTypeType,
    IndexEditionType,
    IndexStatusType,
    IntervalType,
    KeyLocationType,
    MetricTypeType,
    ModeType,
    OrderType,
    PersonaType,
    PrincipalMappingStatusType,
    PrincipalTypeType,
    QueryIdentifiersEnclosingOptionType,
    QueryResultTypeType,
    QuerySuggestionsBlockListStatusType,
    QuerySuggestionsStatusType,
    ReadAccessTypeType,
    RelevanceTypeType,
    SalesforceChatterFeedIncludeFilterTypeType,
    SalesforceKnowledgeArticleStateType,
    SalesforceStandardObjectNameType,
    ScoreConfidenceType,
    ServiceNowAuthenticationTypeType,
    ServiceNowBuildVersionTypeType,
    SharePointVersionType,
    SortOrderType,
    ThesaurusStatusType,
    UserContextPolicyType,
    UserGroupResolutionModeType,
    WebCrawlerModeType,
    ServiceName,
)

def check_value(value: AdditionalResultAttributeValueTypeType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`types_aiobotocore_kendra.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from types_aiobotocore_kendra.type_defs import (
    AccessControlListConfigurationTypeDef,
    AclConfigurationTypeDef,
    AdditionalResultAttributeTypeDef,
    AdditionalResultAttributeValueTypeDef,
    AssociateEntitiesToExperienceRequestRequestTypeDef,
    AssociateEntitiesToExperienceResponseTypeDef,
    AssociatePersonasToEntitiesRequestRequestTypeDef,
    AssociatePersonasToEntitiesResponseTypeDef,
    AttributeFilterTypeDef,
    AuthenticationConfigurationTypeDef,
    BasicAuthenticationConfigurationTypeDef,
    BatchDeleteDocumentRequestRequestTypeDef,
    BatchDeleteDocumentResponseFailedDocumentTypeDef,
    BatchDeleteDocumentResponseTypeDef,
    BatchGetDocumentStatusRequestRequestTypeDef,
    BatchGetDocumentStatusResponseErrorTypeDef,
    BatchGetDocumentStatusResponseTypeDef,
    BatchPutDocumentRequestRequestTypeDef,
    BatchPutDocumentResponseFailedDocumentTypeDef,
    BatchPutDocumentResponseTypeDef,
    CapacityUnitsConfigurationTypeDef,
    ClearQuerySuggestionsRequestRequestTypeDef,
    ClickFeedbackTypeDef,
    ColumnConfigurationTypeDef,
    ConfluenceAttachmentConfigurationTypeDef,
    ConfluenceAttachmentToIndexFieldMappingTypeDef,
    ConfluenceBlogConfigurationTypeDef,
    ConfluenceBlogToIndexFieldMappingTypeDef,
    ConfluenceConfigurationTypeDef,
    ConfluencePageConfigurationTypeDef,
    ConfluencePageToIndexFieldMappingTypeDef,
    ConfluenceSpaceConfigurationTypeDef,
    ConfluenceSpaceToIndexFieldMappingTypeDef,
    ConnectionConfigurationTypeDef,
    ContentSourceConfigurationTypeDef,
    CreateDataSourceRequestRequestTypeDef,
    CreateDataSourceResponseTypeDef,
    CreateExperienceRequestRequestTypeDef,
    CreateExperienceResponseTypeDef,
    CreateFaqRequestRequestTypeDef,
    CreateFaqResponseTypeDef,
    CreateIndexRequestRequestTypeDef,
    CreateIndexResponseTypeDef,
    CreateQuerySuggestionsBlockListRequestRequestTypeDef,
    CreateQuerySuggestionsBlockListResponseTypeDef,
    CreateThesaurusRequestRequestTypeDef,
    CreateThesaurusResponseTypeDef,
    CustomDocumentEnrichmentConfigurationTypeDef,
    DataSourceConfigurationTypeDef,
    DataSourceGroupTypeDef,
    DataSourceSummaryTypeDef,
    DataSourceSyncJobMetricTargetTypeDef,
    DataSourceSyncJobMetricsTypeDef,
    DataSourceSyncJobTypeDef,
    DataSourceToIndexFieldMappingTypeDef,
    DataSourceVpcConfigurationTypeDef,
    DatabaseConfigurationTypeDef,
    DeleteDataSourceRequestRequestTypeDef,
    DeleteExperienceRequestRequestTypeDef,
    DeleteFaqRequestRequestTypeDef,
    DeleteIndexRequestRequestTypeDef,
    DeletePrincipalMappingRequestRequestTypeDef,
    DeleteQuerySuggestionsBlockListRequestRequestTypeDef,
    DeleteThesaurusRequestRequestTypeDef,
    DescribeDataSourceRequestRequestTypeDef,
    DescribeDataSourceResponseTypeDef,
    DescribeExperienceRequestRequestTypeDef,
    DescribeExperienceResponseTypeDef,
    DescribeFaqRequestRequestTypeDef,
    DescribeFaqResponseTypeDef,
    DescribeIndexRequestRequestTypeDef,
    DescribeIndexResponseTypeDef,
    DescribePrincipalMappingRequestRequestTypeDef,
    DescribePrincipalMappingResponseTypeDef,
    DescribeQuerySuggestionsBlockListRequestRequestTypeDef,
    DescribeQuerySuggestionsBlockListResponseTypeDef,
    DescribeQuerySuggestionsConfigRequestRequestTypeDef,
    DescribeQuerySuggestionsConfigResponseTypeDef,
    DescribeThesaurusRequestRequestTypeDef,
    DescribeThesaurusResponseTypeDef,
    DisassociateEntitiesFromExperienceRequestRequestTypeDef,
    DisassociateEntitiesFromExperienceResponseTypeDef,
    DisassociatePersonasFromEntitiesRequestRequestTypeDef,
    DisassociatePersonasFromEntitiesResponseTypeDef,
    DocumentAttributeConditionTypeDef,
    DocumentAttributeTargetTypeDef,
    DocumentAttributeTypeDef,
    DocumentAttributeValueCountPairTypeDef,
    DocumentAttributeValueTypeDef,
    DocumentInfoTypeDef,
    DocumentMetadataConfigurationTypeDef,
    DocumentRelevanceConfigurationTypeDef,
    DocumentTypeDef,
    DocumentsMetadataConfigurationTypeDef,
    EntityConfigurationTypeDef,
    EntityDisplayDataTypeDef,
    EntityPersonaConfigurationTypeDef,
    ExperienceConfigurationTypeDef,
    ExperienceEndpointTypeDef,
    ExperienceEntitiesSummaryTypeDef,
    ExperiencesSummaryTypeDef,
    FacetResultTypeDef,
    FacetTypeDef,
    FailedEntityTypeDef,
    FaqStatisticsTypeDef,
    FaqSummaryTypeDef,
    GetQuerySuggestionsRequestRequestTypeDef,
    GetQuerySuggestionsResponseTypeDef,
    GetSnapshotsRequestRequestTypeDef,
    GetSnapshotsResponseTypeDef,
    GoogleDriveConfigurationTypeDef,
    GroupMembersTypeDef,
    GroupOrderingIdSummaryTypeDef,
    GroupSummaryTypeDef,
    HierarchicalPrincipalTypeDef,
    HighlightTypeDef,
    HookConfigurationTypeDef,
    IndexConfigurationSummaryTypeDef,
    IndexStatisticsTypeDef,
    InlineCustomDocumentEnrichmentConfigurationTypeDef,
    JsonTokenTypeConfigurationTypeDef,
    JwtTokenTypeConfigurationTypeDef,
    ListDataSourceSyncJobsRequestRequestTypeDef,
    ListDataSourceSyncJobsResponseTypeDef,
    ListDataSourcesRequestRequestTypeDef,
    ListDataSourcesResponseTypeDef,
    ListEntityPersonasRequestRequestTypeDef,
    ListEntityPersonasResponseTypeDef,
    ListExperienceEntitiesRequestRequestTypeDef,
    ListExperienceEntitiesResponseTypeDef,
    ListExperiencesRequestRequestTypeDef,
    ListExperiencesResponseTypeDef,
    ListFaqsRequestRequestTypeDef,
    ListFaqsResponseTypeDef,
    ListGroupsOlderThanOrderingIdRequestRequestTypeDef,
    ListGroupsOlderThanOrderingIdResponseTypeDef,
    ListIndicesRequestRequestTypeDef,
    ListIndicesResponseTypeDef,
    ListQuerySuggestionsBlockListsRequestRequestTypeDef,
    ListQuerySuggestionsBlockListsResponseTypeDef,
    ListTagsForResourceRequestRequestTypeDef,
    ListTagsForResourceResponseTypeDef,
    ListThesauriRequestRequestTypeDef,
    ListThesauriResponseTypeDef,
    MemberGroupTypeDef,
    MemberUserTypeDef,
    OneDriveConfigurationTypeDef,
    OneDriveUsersTypeDef,
    PersonasSummaryTypeDef,
    PrincipalTypeDef,
    ProxyConfigurationTypeDef,
    PutPrincipalMappingRequestRequestTypeDef,
    QueryRequestRequestTypeDef,
    QueryResultItemTypeDef,
    QueryResultTypeDef,
    QuerySuggestionsBlockListSummaryTypeDef,
    RelevanceFeedbackTypeDef,
    RelevanceTypeDef,
    ResponseMetadataTypeDef,
    S3DataSourceConfigurationTypeDef,
    S3PathTypeDef,
    SalesforceChatterFeedConfigurationTypeDef,
    SalesforceConfigurationTypeDef,
    SalesforceCustomKnowledgeArticleTypeConfigurationTypeDef,
    SalesforceKnowledgeArticleConfigurationTypeDef,
    SalesforceStandardKnowledgeArticleTypeConfigurationTypeDef,
    SalesforceStandardObjectAttachmentConfigurationTypeDef,
    SalesforceStandardObjectConfigurationTypeDef,
    ScoreAttributesTypeDef,
    SearchTypeDef,
    SeedUrlConfigurationTypeDef,
    ServerSideEncryptionConfigurationTypeDef,
    ServiceNowConfigurationTypeDef,
    ServiceNowKnowledgeArticleConfigurationTypeDef,
    ServiceNowServiceCatalogConfigurationTypeDef,
    SharePointConfigurationTypeDef,
    SiteMapsConfigurationTypeDef,
    SortingConfigurationTypeDef,
    SqlConfigurationTypeDef,
    StartDataSourceSyncJobRequestRequestTypeDef,
    StartDataSourceSyncJobResponseTypeDef,
    StatusTypeDef,
    StopDataSourceSyncJobRequestRequestTypeDef,
    SubmitFeedbackRequestRequestTypeDef,
    SuggestionHighlightTypeDef,
    SuggestionTextWithHighlightsTypeDef,
    SuggestionTypeDef,
    SuggestionValueTypeDef,
    TagResourceRequestRequestTypeDef,
    TagTypeDef,
    TextDocumentStatisticsTypeDef,
    TextWithHighlightsTypeDef,
    ThesaurusSummaryTypeDef,
    TimeRangeTypeDef,
    UntagResourceRequestRequestTypeDef,
    UpdateDataSourceRequestRequestTypeDef,
    UpdateExperienceRequestRequestTypeDef,
    UpdateIndexRequestRequestTypeDef,
    UpdateQuerySuggestionsBlockListRequestRequestTypeDef,
    UpdateQuerySuggestionsConfigRequestRequestTypeDef,
    UpdateThesaurusRequestRequestTypeDef,
    UrlsTypeDef,
    UserContextTypeDef,
    UserGroupResolutionConfigurationTypeDef,
    UserIdentityConfigurationTypeDef,
    UserTokenConfigurationTypeDef,
    WebCrawlerConfigurationTypeDef,
    WorkDocsConfigurationTypeDef,
)

def get_structure() -> AccessControlListConfigurationTypeDef:
    return {
      ...
    }
```

<a id="versioning"></a>

## Versioning

`types-aiobotocore-kendra` version is the same as related `boto3` version and
follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="documentation"></a>

## Documentation

All type annotations can be found in
[types-aiobotocore-kendra docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_kendra/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
